   .org  16509       ; REM code - relocator

;; de = fname pointer, with optional start,length;  a = operation.: 0 = load, 1-7f = delete, 80-ff = save
;;
api_fileop     .equ $1ff8

   .byte 0,1         ; 1 REM ....
   .word end-rem
   
rem:
   .byte $ea

   ; ensure RAM is paged LOW on zxpand

   ld    bc,$e007
   ld    a,$b2
   out   (c),a

   ; go FAST
 
   call $02e7

   ; move code to 8K and jump there
   
   ld    hl,start
   ld    de,$2000
   ld    bc,end-start
   ldir
   jp    $2000

start:
   ; load the required program

   ld    de,datafileload-(start-$2000)
   xor   a
   call  api_fileop

   ; patch the program

   ld    hl,LRPATCH-(start-$2000)
   ld    ($4490),hl

   ld    hl,FRPATCH-(start-$2000)
   ld    ($44cb),hl

   ld    hl,FRPATCH-(start-$2000)
   ld    ($5154),hl

   ld    hl,UDPATCH-(start-$2000)
   ld    ($56b2),hl

   ; start it
   ld    hl,($4002)     ; ERR-SP
   ld    sp,hl
   jp    $0207          ; SLOW/FAST



LRPATCH:
   call  $1ffe          ; JOYSTK
   bit   5,a
   jr    nz,notleft

   ld    h,$fd
   ret

notleft:
   bit   4,a
   jr    nz,notright

   ld    h,$f7
   ret

notright:
   call  $02bb          ; KEYBOARD
   ret


UDPATCH:
   call  $1ffe          ; JOYSTK
   bit   7,a
   jr    nz,notup

   ld    l,$fb
   ret

notup:
   bit   7,a
   jr    nz,notdown

   ld    l,$7f
   ret

notdown:
   call  $02bb          ; KEYBOARD
   ret


FRPATCH:
   call  $1ffe          ; JOYSTK
   and   8
   jr    nz,nofr

   ld    h,$fb
   ret
   
nofr:   
   call  $02bb          ; KEYBOARD
   ret



datafileload:
   ;     "INVASION.P"
   .db   $2E,$33,$3B,$26,$38,$2E,$34,$33,$1B,$35+$80

   .byte $76


end:
  
   .end
